function $feedly( msg  )
{
	var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
   	                     	.getService(Components.interfaces.nsIConsoleService);

	consoleService.logStringMessage( "[feedly][extension]" + msg );
}

function askIncludeScript( partialURI, onComplete )
{
	try
	{
		include( partialURI, true );
	}
	catch( ignore )
	{
		// some files might not exist. no worries
	}
	devhd.fn.callback( onComplete );
}

var feedlyScripts = {};

function include( partialURI, maybe )
{
	if( feedlyScripts[ partialURI ] == true )
		return;

	// Load JS libraries
	var u = "chrome://feedly/content/app/" + partialURI;
	try
	{
		var jsl = Cc["@mozilla.org/moz/jssubscript-loader;1"]
						.getService(Ci.mozIJSSubScriptLoader);

		jsl.loadSubScript( u );

		feedlyScripts[ partialURI ] = true;
	}
	catch( e )
	{
		feedlyScripts[ partialURI ] = true;
		if( maybe != true )
		{
			$feedly( "[loader] failed to load: " + u + " because <" + e.name + ": " + e.message + "> in " + e.fileName + "@" + e.lineNumber );
			throw e;
		}
	}
}

include( "include-fx-base.js"   );

var feedlyExtension = function()
{
	var NS_BINDING_ABORTED = 0x804b0002;

	var feedlyIncluded = false;
	function includeFeedlyLibraries()
	{
		if( feedlyIncluded == false )
		{
			include( "include-fx-app.js" );
			feedlyIncluded = true;
		}
	}
	
	var miniIncluded = false;
	function includeMiniLibraries()
	{
		if( miniIncluded == false )
		{
			include( "include-fx-mini.js" );
			miniIncluded = true;
		}
	}

	var that = {};

	var ioService = Components.classes["@mozilla.org/network/io-service;1"]
							   .getService(Components.interfaces.nsIIOService);

	function newURI( url )
	{
		return ioService.newURI( url, "utf-8", null );
	}

	//---------------------------------------------------------------------
	// Browser progress listener
	//---------------------------------------------------------------------
	var SPLASH_APP_URL 	= "chrome://feedly/content/boot/splash.htm";
	var OFFLINE_URL 	= "http://www.feedly.com/offline.htm"
	var FEEDLY_HOME_URL = "http://www.feedly.com/home";

	var continueURL = null;
	var core = null;

	function isFeedlyURL( url )
	{
		return url == null ? false : url.indexOf( FEEDLY_HOME_URL ) == 0;
	}

	that.onLocationChange = function ( wp, request, locationURI )
	{
		try
		{
			var message;

			///D $feedly( "[extension][onLocationChange]" + locationURI.spec +" -- core:" + core + " -- request: " + request );

			if (locationURI == null )
			{
				// this sometimes happens, seems benign now ... but now idea why ?
				return ;
			}

			// NOTIFY: URL bar
			if( request == null )
			{
				// request == null means that the user is switching tabs. try to keep the +f
				// button consistent with the tab content.
				that.onPageShown();
			}

			// NOTIFY: where service
			if( core != null && core.getState() == "STARTED" )
			{
				var where = core.service( "where" );
				if( where != null )
					where.publish( new String( locationURI.spec ) );				
			}
			
			// ENRICH: www.feedly.com website
			if( locationURI.spec == "http://www.feedly.com/" || locationURI.spec == "http://www.feedly.com/index.html" )
			{
				createWebsiteHome();
				return;
			}

			// ENRICH: Google login page
			if( locationURI.spec.indexOf( "continue=https://www.google.com/reader/view/feedly.login" ) > 0 )
			{
				createLoginHome();
				return;
			}

			// INTERCEPT: Logout
			if( locationURI.spec.indexOf( "https://encrypted.google.com/search?q=feedly.logout" ) == 0 )
			{
				// notify core that it should stop.
				$feedly( "[extension] detected logout from google" );      // non-i18n
				core.askSyncIdentity( "logout" ); // non-i18n

				wp.DOMWindow.top.document.location = FEEDLY_HOME_URL;

				return;
			}

			// INTERCEPT: Login
			if( locationURI.spec == "https://www.google.com/reader/view/feedly.login" )
			{
				if( request != null)
					request.cancel( NS_BINDING_ABORTED );

				// notify core that is should be able to start
				core.askSyncIdentity( "login" ); // non-i18n

				wp.DOMWindow.top.document.location = continueURL || FEEDLY_HOME_URL;

				return;
			}


			// INTERCEPT: RSS subscription
			if( locationURI.spec.indexOf( "http://www.feedly.com/subscribe.htm?feedURL=" ) == 0 )
			{
				request.cancel( NS_BINDING_ABORTED );

				var feedURL = locationURI.spec.substring( "http://www.feedly.com/subscribe.htm?feedURL=".length );
				wp.DOMWindow.top.document.location = FEEDLY_HOME_URL + "#subscription/feed/" + feedURL + "[action.subscribe";
				return;
			}

			if( isFeedlyURL( locationURI.spec ) )
			{
				// PRE-CONDITION: Third party cookies
				try
				{
					var prefs = Components.classes["@mozilla.org/preferences-service;1"]
										  .getService( Components.interfaces.nsIPrefBranch2 );

					// does the user support third party cookies?
					var cb = prefs.getIntPref( "network.cookie.cookieBehavior" ) ;
					if( cb != null && cb != 0 )
		 			{
						$feedly( "[cookie behavior][warning] setting:" + cb  );

						// try to see if the user has manually set the right set of exceptions.
						var exceptions = devhd.utils.FirefoxUtils.getPreference( "exceptions" );

						if( exceptions != "done")
						{
							if( request != null)
								request.cancel( NS_BINDING_ABORTED );

							wp.DOMWindow.top.document.location = "chrome://feedly/content/app/warning.htm";
							return;
						}
					}
				}
				catch( e )
				{
					$feedly( "[third party cookies][exception]" + e.name + " -- " + e.message );
				}

				// PRE-CONDITION: Core not null
				if( core == null )
				{
					if( request != null)
						request.cancel( NS_BINDING_ABORTED );

					var msg = lastLoadError != null ? lastLoadError : "Request reached extension before core has been loaded." // non-i18n
					wp.DOMWindow.top.document.location = OFFLINE_URL + "?012-" + msg + "--feedly_" + feedlyApplicationVersion+ "_firefox";
				}
	
				// INTERCEPT: no embedding!
				if( wp.DOMWindow != wp.DOMWindow.top )
				{
					request.cancel( NS_BINDING_ABORTED );
					wp.DOMWindow.top.document.location = locationURI.spec;
					return;
				}

				// ATTACH: attach a feedly home to the page
				var currentLocation = new String(getBrowser().selectedBrowser.contentDocument.location);
				var currentDocument = getBrowser().selectedBrowser.contentDocument;
				if( currentDocument == null || currentDocument.body == null || currentDocument.body.getAttribute( "_homeId" ) == null )
				{
					createFeedlyHome( locationURI.spec );
				}
			}
		}
		catch( e )
		{
			var msg = devhd.utils.ExceptionUtils.formatError( "process location changed", e );
			$feedly( "[dispatcher]" + msg );
		}
	}

	// event notifying us that the boot has finished to load the core in memory
	var lastLoadError = null;
	that.onCoreLoaded = function( theCore )
	{
		core = theCore;
	}

	var MY_EXTENSION_UUID = "feedly@devhd";
	var feedlyUninstallObserver =
	{
		_uninstall : false,
		observe : function(subject, topic, data)
		{
	  		if( topic == "em-action-requested" )
			{
	    		subject.QueryInterface(Components.interfaces.nsIUpdateItem);
				if(subject.id == MY_EXTENSION_UUID )
				{
					var flid   = devhd.utils.FirefoxUtils.getPreference( "welcome.flid"   );

					// try to determine duration based on flid
					var duration = "-";
					try
					{
						var delta = new Date().getTime() - flid.split( "-" )[ flid.split( "-" ).length - 2 ];

						if( delta  < devhd.utils.DurationUtils.HOURS( 1 ) )
						{
							duration = "1h";
						}
						else if( delta  < devhd.utils.DurationUtils.DAYS( 1 ) )
						{
							duration = "1d";
						}
						else if( delta  < devhd.utils.DurationUtils.DAYS( 7 ) )
						{
							duration = "1w";
						}
						else
						{
							duration = Math.ceil( delta / devhd.utils.DurationUtils.DAYS( 30 ) ) + "m";
						}

						// try to detect 2 more edge cases - not being logged in and not having subscribed to
						// any sources.
						if( core.getUserId() == null || core.getUserId() == "-" )
						{
							duration += "/A"
						}
						else
						{
							var reader = core.service( "reader" );
							if( reader != null && reader.isReady() == true )
							{
								var subs = reader.listSubscriptions();
								if( subs.length == 0 )
								{
									duration += "/E";										
								}
								else if( subs.length < 5 )
								{
									duration += "/S"
								}
								else if( subs.length < 20 )
								{
									duration += "/M"
								}
								else if( subs.length < 40 )
								{
									duration += "/L"
								}
								else
								{
									duration += "/XL"
								}
							}
						}
					}
					catch( ignore )
					{

					}

	      			if( data == "item-uninstalled" )
					{
						try
						{
							var wccr =  Cc["@mozilla.org/embeddor.implemented/web-content-handler-registrar;1"]
										.getService(Ci.nsIWebContentConverterService);

							wccr.removeContentHandler( "application/vnd.mozilla.maybe.feed", "http://www.feedly.com/subscribe.htm?feedURL=%s" );

							$feedly( "[un-install] removed feedly RSS content handler" );
						}
						catch( e )
						{
							$feedly( "[un-install] failed to remove content handler" + e.name + " -- " + e.message );
						}

						devhd.utils.FirefoxUtils.setPreference( "shortcut",   "none" );
	        			devhd.utils.FirefoxUtils.setPreference( "exceptions", "none" );

						// In case there are multiple browser window open, we only want one to open
						// the goodbye page
						if( core != null && core.uninstalled == true )
							return;
						
						// use uninstalled semaphore so that if there are multiple windows open, only one loads
						// the goodbye page.
						if( core != null )
							core.uninstalled = true;

						$feedly( "[extension-manager][feedly][uninstall]" + duration )

						loadPage( "http://www.feedly.com/goodbye.v14.htm?uninstall|" + duration );
	      			}
	      			else if( data == "item-disabled" )
					{
						// In case there are multiple browser window open, we only want one to open
						// the goodbye page
						if( core != null && core.disabled == true )
							return;

						// Programmatically remove the feedly button to the toolbar
						//
						try
						{
							var firefoxnav = document.getElementById( "nav-bar" );
							var curSet = firefoxnav.currentSet;

						  	if( curSet.indexOf( "feedly-toolbar-button" ) > 0 )
						   	{
								var set = curSet.replace( "feedly-toolbar-button,", "");
								set = set.replace( "feedly-toolbar-button", "");

								firefoxnav.setAttribute("currentset", set);
						     	firefoxnav.currentSet = set;
						     	document.persist( "nav-bar", "currentset" );

						     	// If you don't do the following call, funny things happen
						     	try
								{
						       		BrowserToolboxCustomizeDone( true );

									$feedly( "[extension] removed the feedly shortcut button to the firefox navigation bar" );
						     	}
						     	catch( ignore )
								{
							   		$feedly( "[extension]failed to remove shortcut." );
								}

								FirefoxUtils.setPreference( "shortcut", "none" );
						 	}
						}
						catch( ignore )
						{
					   		$feedly( "[extension]failed to remove feedly button to toolbar." );
						}

						// use disabled semaphore so that if there are multiple windows open, only one loads
						// the goodbye page.
						if( core != null )
							core.disabled = true;

						$feedly( "[extension-manager][feedly][disable]" + duration )

						loadPage( "http://www.feedly.com/goodbye.v14.htm?disable|" + duration );

	      			}
					else if( data == "item-cancel-action" )
					{
						$feedly( "[extension-manager][feedly][cancel]" + subject.id + " -- " + data )
	        			devhd.utils.FirefoxUtils.setPreference( "firstrun", "done" );
	      			}
	    		}
	  		}
			else if( topic == "quit-application-granted" )
			{
	    		this.unregister();
	  		}
		},
		register : function()
		{
	 		var observerService = Components.classes["@mozilla.org/observer-service;1"]
											.getService(Components.interfaces.nsIObserverService);

	 		observerService.addObserver(this, "em-action-requested", false);
	 		observerService.addObserver(this, "quit-application-granted", false);
		},
		unregister : function()
		{
	  		var observerService = Components.classes["@mozilla.org/observer-service;1"]
											.getService(Components.interfaces.nsIObserverService);

	  		observerService.removeObserver(this,"em-action-requested");
	  		observerService.removeObserver(this,"quit-application-granted");
		}
	}



	that.onLoad = function()
  	{
		// listen for users un-installing the extension and clean up the first run preference
		// so that we can run the first run page again if they ever decide to re-install it
		// sometimes in the future.
		try
		{
			feedlyUninstallObserver.register();
		}
		catch( e )
		{
			// ignore
		}

		var shortcut = devhd.utils.FirefoxUtils.getPreference( "shortcut" );
		if( shortcut != feedlyMajorVersion )
		{
			var toolbar = devhd.utils.FirefoxUtils.getPreference( "toolbar" );
			if( toolbar != "off" )
			{
				// Programmatically add the feedly button to the toolbar
				try
				{
					var firefoxnav = document.getElementById( "nav-bar" );
					var curSet = firefoxnav.currentSet;
				  	if( curSet.indexOf( "feedly-toolbar-button" ) == -1 )
				   	{
						$feedly( "[extension] adding the feedly shortcut button to the firefox navigation bar" );

				    	var set;

				     	// Place the button before the urlbar
				     	if( curSet.indexOf("urlbar-container") != -1 )
				       		set = curSet.replace(/urlbar-container/, "feedly-toolbar-button,urlbar-container");
				     	else  // at the end
				       		set = firefoxnav.currentSet + ",feedly-toolbar-button";

						firefoxnav.setAttribute("currentset", set);
				     	firefoxnav.currentSet = set;
				     	document.persist("nav-bar", "currentset");

				     	// If you don't do the following call, funny things happen
				     	try
						{
				       		BrowserToolboxCustomizeDone(true);
				     	}
				     	catch( ignore )
						{
					   		$feedly( "[extension]failed to customize toolbar." );
						}
				 	}
				}
				catch( ignore )
				{
			   		$feedly( "[extension]failed to add feedly button to toolbar." );
				}
			}

			devhd.utils.FirefoxUtils.setPreference( "shortcut", feedlyMajorVersion );
		}

		// Make sure that a wave is assigned to this installation
		var wave = devhd.utils.FirefoxUtils.getPreference( "welcome.wave" )
		if( wave == null )
			devhd.utils.FirefoxUtils.setPreference( "welcome.wave", new Date().getFullYear() + "." + devhd.utils.DateUtils.getWeek( new Date() ) );

		// Make sure that there is a flid assigned to this installation
		var flid = devhd.utils.FirefoxUtils.getPreference( "welcome.flid" );
		if( flid == null )
		{
			var locale = devhd.utils.BrowserUtils.getLocale();
			var wave   = devhd.utils.FirefoxUtils.getPreference( "welcome.wave" );
			var time   = new Date().getTime();
			var rand   = Math.ceil( Math.random() * 250000 );

			flid = locale + "-" + wave + "-" + time + "-" + rand;

			devhd.utils.FirefoxUtils.setPreference( "welcome.flid", flid );
		}

		var firstrun = devhd.utils.FirefoxUtils.getPreference( "firstrun" );		
		if( firstrun != feedlyMajorVersion )
		{
			devhd.utils.FirefoxUtils.setPreference( "firstrun", feedlyMajorVersion );
			window.setTimeout( function(){ loadPage( "http://www.feedly.com/home" ) }, 100 );
		}
  	};

	that.onPageShown = function()
	{
		// LIST OF TASK TO PERFORM *THE FIRST TIME* THE PAGE IS SHOWN
		//
		insertMiniButton();
	}

	function insertMiniButton()
	{
		// if the user is not logged in then do not activate the feedly mini extension
		if( core == null )
			return;

		var document = getBrowser().selectedBrowser.contentDocument;

		// This seems to happen when the request gets cancelled. It does not interfer with
		// the execution of the mini.
		if( document.body == null )
		{
			///D $feedly( "[mini] document is null. Ignoring pageshow event." );
			return;
		}

		if( document.location.href.indexOf( "http://" ) != 0 )
			return;

		if( document.location.href == "about:blank" )
			return;

		if( document.body.getAttribute( "data-feedly-processed" ) != null )
			return;

		document.body.setAttribute( "data-feedly-processed", "yes" );
						
		// we need the preferences to be ready to determine the mini level.
		var preferences = core.service( "preferences" );
		if( preferences == null || preferences.isReady() == false )
			return;
		
		var miniOn = preferences.getPreference( "miniOn" )
		if( miniOn != "yes" )
			return;

		if( devhd.mini.FilterUtils.ignore( new String( document.location ), preferences.getPreference( "miniExcludeList" ) )  )
			return;
		
		var bottom = preferences.getPreference( "miniBottom" );

		devhd.mini.UIUtils.insertIcon( getBrowser().selectedBrowser.contentWindow, bottom, createMiniHome );
	}

	that.onUnload = function()
  	{
		core = null;

	   	that.initialized = false;

		feedlyUninstallObserver = null;
   	};

	that.onCommand = function( e )
	{
		loadPage( FEEDLY_HOME_URL );
	};

	function loadPage( pageURI )
	{
		var tabBrowser = getBrowser();

		// navigate through list of existing tabs
		var tabs = tabBrowser.tabContainer.childNodes;
		for( var i = 0; i < tabs.length; i++ )
		{
			var aTab = tabs[ i ];
			var aBrowser = tabBrowser.getBrowserForTab( aTab );
			var currentLocationURI = new String( aBrowser.contentDocument.location );

			if( currentLocationURI.indexOf( FEEDLY_HOME_URL ) == 0 )
			{
				if( aBrowser.contentDocument.location != pageURI )
					aBrowser.contentDocument.location.href = pageURI;

				tabBrowser.selectedTab = aTab;
				return;
			}
		};

		// no pre-existing tabs. create a new one.
  		var tab = tabBrowser.addTab( pageURI );
		var aBrowser = tabBrowser.getBrowserForTab( tab );
 	  	tabBrowser.selectedTab = tab;
		return;
	};

	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// FEEDLY HOME    																					//
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	var homes = [];
	var nextHomeId = 0;

	function createFeedlyHome( uri )
	{
		try
		{
			// Lazy loading of the feedly libraries
			includeFeedlyLibraries();

			// make sure that the cookie
			var cookieMonster = core.service( "cookieMonster" );
			if( cookieMonster != null )
				cookieMonster.setCookieString( "http://www.feedly.com", "feedlyVersion=" + feedlyApplicationVersion + "; path=/; domain=.feedly.com" );

			// get access to the document element of the currently selected tab
			var window         = getBrowser().selectedBrowser.contentWindow;
  			var document       = getBrowser().selectedBrowser.contentDocument;
			var streets		   = null;
			var homeId 		   = null;

			function reloadFeedly( message )
			{
				try
				{
					unloadFeedly();
				}
				catch( e )
				{
					$feedly( "[on home][reload] exception during unload:" + e.name + " -- " + e.message );
				}
				
				try
				{
					window.location.hash = "";
					document.body.innerHTML = "<div style='color:#C0C0C0; font-size:12px; font-family:sans-serif; padding-top:200px; text-align:center'>Synchronizing feedly...<span id='loadingStatus'></span></div>" 
				}
				catch( e )
				{
					$feedly( "[on home][reload] exception during prepare:" + e.name + " -- " + e.message );		
				}

				window.setTimeout( function(){ loadFeedly() }, 500 );
			}

			var feedlyLoader = function( )
			{
				try
				{
					window.removeEventListener( "load", feedlyLoader, false );

					loadFeedly();
				}
				catch( e )
				{
					var msg = devhd.utils.ExceptionUtils.formatError( "load the Feedly user interface", e );
					window.location = OFFLINE_URL + "?015-" + msg + "--feedly_" + feedlyApplicationVersion+ "_firefox"
				}
			}

			function loadFeedly( )
			{
				try
				{
					homeId = "home" + nextHomeId++;

					streets = devhd.streets.create();
					streets.onIdentityChanged( reloadFeedly );
					streets.attachDocument( document );
					streets.connect( core );
					streets.load( feedlyStreets );

					homes[ homeId ] = streets;
					document.body.setAttribute( "_homeId", homeId );

					streets.askStart( 	function()
										{
											if( streets == null )
												return;
											
											streets.service( "feedly" ).loadStartPage();
										},
										function( status )
										{
											if( status.indexOf( "fail") > -1 )
											{
												document.location = "http://www.feedly.com/offline.htm?010-services_not_started--" + status + "--feedly_" + feedlyApplicationVersion+ "_firefox";
											}
											else
											{
												var statusElem = document.getElementById( "loadingStatus" );
												if( statusElem != null )
													statusElem.innerHTML = status;
											}
										});

					window.addEventListener( "unload",  unloadFeedly, 		false );
				}
				catch( e )
				{
					var msg = devhd.utils.ExceptionUtils.formatError( "load the Feedly user interface", e );
					window.location = OFFLINE_URL + "?015-" + msg + "--feedly_" + feedlyApplicationVersion+ "_firefox"
				}
			}

			function unloadFeedly()
			{
				try
				{
					window.removeEventListener( "unload", unloadFeedly, false );

					// this is where we would do our clean up
					if( streets != null )
						streets.askShutdown();

					streets = null;
					
					delete homes[ homeId ];

					///D $feedly( "[home][feedly]unloaded" );

				}
				catch( e )
				{
					streets 	= null;

					delete homes[ homeId ];

					var msg = devhd.utils.ExceptionUtils.formatError( "unload feedly page", e )
					$feedly( "[home][feedly][error]" + msg );
				}
			}

			// we need to check and see if the window has been already loaded in a background thread
			if( document.body != null )
				loadFeedly();
			else
				window.addEventListener( "load", feedlyLoader, false );
				
		}
		catch( e )
		{
			$feedly( "[home][feedly][error]" + e.name + " -- " + e.message + " -- " + e.fileName + " -- " + e.lineNumber );
		}
	}

	////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// MINI     																					          //
	////////////////////////////////////////////////////////////////////////////////////////////////////////////

	function askShowPopup( homeId )
	{
		if( homeId == null )
			return;
		
		// if the user is not logged in then do not activate the feedly mini extension
		if( core == null )
			return;

		// we need the preferences to be ready to determine the mini level.
		var preferences = core.service( "preferences" );
		if( preferences == null || preferences.isReady() == false )
			return;
		
		var tools = preferences.getPreference( "favoriteTools" )
				
		var streets = homes[ homeId ];
		streets.service( "mini" ).show( tools );
	}
	
	function createMiniHome()
	{
		includeMiniLibraries();
		
		var window   = getBrowser().selectedBrowser.contentWindow;
		var document = getBrowser().selectedBrowser.contentDocument;
		var hId = document.body.getAttribute( "_homeId" );
		
		if( hId != null )
		{
			askShowPopup( hId );
			return;
		}
		
		var streets = null;
		var homeId = null;
		
		try
		{
			homeId = "home" + nextHomeId++;
	
			// load and initialize the streets bus
			streets = devhd.streets.create();

			homes[ homeId ] = streets;
			document.body.setAttribute( "_homeId", homeId );

			streets.onIdentityChanged( function(){} );

			streets.connect( core );

			streets.attachDocument( document );	

			streets.load( miniStreets );
			
			streets.askStart( 	function()
								{
									askShowPopup( homeId );
								},
								function( status )
								{
									$feedly( "[feedly] failed to initialize mini because " + status );
								}
								);
		}
		catch( e )
		{
			var msg = devhd.utils.ExceptionUtils.formatError( "load the mini user interface", e );
			$feedly( "[home][mini] " + msg )
		}

		var miniUnloader = 	function()
							{
								try
								{
									window.removeEventListener( "pagehide", miniUnloader, false );
	
									// this is where we would do our clean up
									if( streets != null )
										streets.askShutdown();
		
									streets = null;
	
									delete homes[ homeId ];
	
									///D $feedly( "[home][mini] unloaded" );
								}
								catch( e )
								{
									var msg = devhd.utils.ExceptionUtils.formatError( "unload mini page", e )
									$feedly( "[home][mini][error]" + msg );
								}
							};

		window.addEventListener( "pagehide", miniUnloader, false );
	}

	////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// Website     																					          //
	////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function createWebsiteHome()
	{
		try
		{
			// get access to the document element of the currently selected tab
			var activeBrowser	= getBrowser().selectedBrowser;
			var window         	= activeBrowser.contentWindow;
  			var document       	= activeBrowser.contentDocument;

			window.addEventListener( 	"load",
										function()
										{
											try
											{
												window.removeEventListener( "load", arguments.callee, false );

												var welcomeElem = document.getElementById( "welcome" );
												if( welcomeElem != null )
													welcomeElem.style.display = "inline";

												activeBrowser = null;
												window = null;
												document = null;

											}
											catch( e )
											{
												$feedly( "[home][website][error] failed to load:" + e.name + " -- " + e.message );
											}
										},
										false
										);
		}
		catch( e )
		{
			$feedly( "[home][website][error]" + e.name + " -- " + e.message + " -- " + e.fileName + " -- " + e.lineNumber );
		}
	}

	////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// Website     																					          //
	////////////////////////////////////////////////////////////////////////////////////////////////////////////
	function createLoginHome()
	{
		try
		{
			// get access to the document element of the currently selected tab
			var activeBrowser	= getBrowser().selectedBrowser;
			var window         	= activeBrowser.contentWindow;
  			var document       	= activeBrowser.contentDocument;

			window.addEventListener( 	"load",
										function()
										{
											try
											{
												window.removeEventListener( "load", arguments.callee, false );

												var tds = document.getElementsByTagName( "td" );
												if( tds != null && tds.length > 0 )
													tds[ 0 ].innerHTML = templates.login.layout();

												activeBrowser = null;
												window = null;
												document = null;

											}
											catch( e )
											{
												$feedly( "[home][website][error] failed to load:" + e.name + " -- " + e.message );
											}
										},
										false
										);
		}
		catch( e )
		{
			$feedly( "[home][website][error]" + e.name + " -- " + e.message + " -- " + e.fileName + " -- " + e.lineNumber );
		}
	}

	return that;
}();
