var coreStreets = 
{
    locator:
	{
		factory: "devhd.services.createLocator",
		dependencies: ["preferences"]
	},
	
   cache:
	{
		factory: "devhd.services.createCache",
		dependencies: [ "timers", "store" ]
	},

   store:
	[
		{
			environment:  "firefox",
			factory: 	  "devhd.services.createFirefoxStore",
			dependencies: [ "timers" ]
		},
		{
			environment: "others",
			factory: 	 "devhd.services.createStore"
		}
	],

	timers: 
	[
		{
			environment:  "firefox",
			factory: 	  "devhd.services.createFirefoxTimers",
			dependencies: []
		},
		{
			environment: "others",
			factory: 	 "devhd.services.createTimers"
		}
	],
	
    io:
	[
		{
			environment:  "firefox",
			factory: 	  "devhd.services.createFirefoxIO",
			dependencies: [ "cookieMonster", "where", "timers" ]
		},
		{
			environment: "ipad",
			factory: 	 "devhd.services.createIPadIO",
			dependencies: [ "timers" ]
		},
		{
			environment: "chrome",
			factory: 	 "devhd.services.createBackgroundIO",
			dependencies: [ "timers" ]
		},
		{
			environment: "safari",
			factory: 	 "devhd.services.createBackgroundIO",
			dependencies: [ "timers" ]
		},
		{
			environment: "web",
			factory: 	 "devhd.services.createWebIO",
			dependencies: [ "timers" ]
		}
	],
	
	reco:
	{
		factory: "devhd.services.createReco",
		dependencies: [ "io", "locator", "preferences", "reader", "timers" ]
	},

	bookmarks: 
	[
		{
			environment: "firefox",
			factory: "devhd.services.createFirefoxBookmarks",
			dependencies: [ "repo", "store", "reader", "io" ]
		},
		{
			environment: "chrome",
			factory: "devhd.services.createChromeBookmarks",
			dependencies: [ "repo" ]
		},
		{
			environment: "others",
			factory: 	 "devhd.services.createBookmarks"
		}
	],

    calais:
	{
		factory: "devhd.services.createCalais",
		dependencies: [ "preferences", "locator", "io" ]
	},

	netcaster: 
	{
		factory: "devhd.services.createNetcaster",
		dependencies: [ "io", "locator" ]
	},

	memory: 
	{
		factory: "devhd.services.createMemory"
	},
	
	cookieMonster:
	{
		factory: "devhd.services.createCookieMonster",
		dependencies: ["preferences"]
	},
	
	addressBook:
	{
		factory: "devhd.services.createAddressBook",
		dependencies: ["preferences","locator", "io" , "mailer" ]
	},
	
	mailer:
	{
		factory: "devhd.services.createMailer",
		dependencies: [ "preferences", "locator", "cookieMonster" , "where", "io", "timers" ]
	},
		
	facebook:
	{
		factory: "devhd.services.createFacebook",
		dependencies: [ "preferences", "locator", "where", "io","timers", "cache", "reader" ]
	},

	friendfeed:
	{
		factory: "devhd.services.createFriendfeed",
		dependencies: [ "locator", "io" ]
	},

	digg:
	{
		factory: "devhd.services.createDigg",
		dependencies: [ "preferences", "locator", "cookieMonster", "io" ]
	},

	tumblr:
	{
		factory: "devhd.services.createTumblr",
		dependencies: [ "locator", "io" ]
	},

	google:
	{
		factory: "devhd.services.createGoogle",
		dependencies: [ "repo", "io" ]
	},
	
	tinyURL:
	{
		factory: "devhd.services.createTinyURL",
		dependencies: [ "locator", "io" ]
	},
	
  	profile:
	{
		factory: 	  "devhd.services.createProfile",
		dependencies: [ "locator", "io" ]
	},

  	social:
	{
		factory: "devhd.services.createSocial",
		dependencies: [ "io" ]
	},

    preferences:
	{
		factory: "devhd.services.createPreferences",
		dependencies: ["locator", "io", "timers", "store" ]
	},

	reader: 
	{
		factory: 	  "devhd.services.createReader",
		dependencies: ["preferences", "reco", "io", "locator", "timers", "cache" ]
	},


    keywords:
	{
		factory:          "devhd.services.createKeywords",
		dependencies:     ["locator", "io"]
	},

	sherlock:
	{
		factory: "devhd.services.createSherlock",
		dependencies: ["preferences", "locator", "io", "reader", "delicious" ]
	},

	extractor:
	{
		factory: "devhd.services.createExtractor",
		dependencies: ["io"]
	},

	repo:
	{
		factory: "devhd.services.createRepo",
		dependencies: [ "io", "delicious","timers", "cache", "reader", "bookmarks" ]
	},

	lang:
	{
		factory: "devhd.services.createLang",
		dependencies: [ "io" ]
	},
	
	amazon:
	{
		factory: "devhd.services.createAmazon",
		dependencies: [ "io", "cookieMonster", "preferences", "reader", "timers", "locator", "store" ]
	},
	
	delicious:
	{
		factory: "devhd.services.createDelicious",
		dependencies: [ "io" , "timers", "cache", "repo" ]
	},

	trends:
	[
		{
			environment:  "web",
			factory: 	  "devhd.services.createWebTrends",
 			dependencies: [ "preferences" ]
		},
		{
			environment:  "others",
			factory: "devhd.services.createTrends",
			dependencies: ["locator", "preferences", "reader", "annotator", "reco", "io", "timers"]
		}
	],

	suggesto:
	{
		factory: "devhd.services.createSuggesto",
		dependencies: [ "locator", "io", "reader", "repo" ]
	},

	quotes:
	{
		factory: "devhd.services.createQuoteService",
		dependencies:[ "io" ] 
	},

	portfolio:
	{
		factory: "devhd.services.createPortfolioService",
		dependencies:[ "io", "quotes", "preferences" ]
	},

	annotator:
	{
		factory: "devhd.services.createAnnotator",
		dependencies:["locator","preferences","reader", "io"] 
	},
	
	firefoxGlue:
	[
		{
			environment:  "firefox",
			factory: 	  "devhd.services.createFirefoxGlue"
		}
	],	
	
  	where:
	[
		{
			environment:  "firefox",
			factory: 	  "devhd.services.createFirefoxWhere",
		},
		{
			environment: "others",
			factory: 	 "devhd.services.createWhere"
		}
	],
	
  	tetro:
	[
		{
			environment:  "firefox",
			factory: 	  "devhd.services.createFirefoxTetro",
			dependencies:["where"] 
		},
		{
			environment: "others",
			factory: 	 "devhd.services.createTetro"
		}
	]
}
