// ---------------------------------------------------------------------
// FEEDLY AND ASSOCIATED MODULES
// ---------------------------------------------------------------------
var feedlyStreets = 
{
	feedly:
	{
		factory: "devhd.services.createFeedly",
		dependencies: ["preferences", "reader", "reco", "suggesto", "trends", "popup",
		               "quicklook", "edito", "sherlock", "keywords",
					   "annotator", "signs", "helpSigns", "mailer", "twitter",
					   "profile", "progressDialog", "io","disco","repo",
					   "addressBook", "analytics", "friendfeed", "tumblr", "quickGoto", 
					   "digg", "calais", "amazon",
					   "kodak", "hercule", "memory", "dialog", "effects", "cookieMonster", "channel",
					   "leftNav", "topNav", "delicious", "portfolio", "netcaster", "social", "tinyURL", "back", "bundles", "bookmarks", "lang"
					   ],
		properties:
		{
			sideAreaModuleIds:[ 	
								"financeModule",
			                    "profileModule",


								"featuredModule",
								"dashboardModule",

								"favoriteSourcesModule",
								"otherSourcesModule",

								"fusionModule",

			                    "discoverModule",

			                    "aboutModule",

								"likersModule",
								
								"timelineModule", 

								"essentialsModule",
								
								"karmaModule", 
								
								"portfolioModule", 

								"sponsorsModule",

								"followsModule", 

								"recommendsModule", 
								"tweetsModule",
								"youtubeModule",
								"flickrModule",

								"tipsModule",
								"bookmarkSuggestionsModule",
								"googleSuggestionsModule",
								"twitterSuggestionsModule",
								"facebookSuggestionsModule",
								"causesModule"
							  ]		
			}
	},

	addSubscriptionForm:
	{
		factory: "devhd.forms.createAddSubscriptionForm",
		dependencies: [ "reader", "dialog" ]
	},

	editSubscriptionForm:
	{
		factory: "devhd.forms.createEditSubscriptionForm",
		dependencies: [ "reader", "dialog" ]
	},

	
// ---------------------------------------------------------------------
// SIDEAREA MODULES
// ---------------------------------------------------------------------

    leftNav:
	{
		factory: "devhd.services.createLeftNav",
		dependencies: [ "reader", "effects", "preferences", "feedly" ]
	},

    topNav:
	{
		factory: "devhd.services.createTopNav",
		dependencies: [ "reader", "feedly", "effects", "popup", "preferences" ]
	},
	
    timelineModule:
	{
		factory: "devhd.modules.createTimelineModule",
		dependencies: [ "twitter", "preferences", "dialog", "tinyURL", "signs" ]
	},

    karmaModule:
	{
		factory: "devhd.modules.createKarmaModule",
		dependencies: [ "twitter", "tinyURL" ]
	},

   	portfolioModule:
	{
		factory: "devhd.modules.createPortfolioModule",
		dependencies: [ "preferences", "portfolio", "sherlock", "reader" ]
	},

    tweetsModule:
	{
		factory: "devhd.modules.createTweetsModule",
		dependencies: [ "twitter", "reader", "preferences" ]
	},

    flickrModule:
	{
		factory: "devhd.modules.createFlickrModule",
		dependencies: ["sherlock", "preferences" ]
	},

	youtubeModule:
	{
		factory: "devhd.modules.createYoutubeModule",
		dependencies: ["sherlock", "preferences"]
	},

    profileModule:
	{
		factory: "devhd.modules.createProfileModule",
		dependencies: ["reader", "social", "kodak", "friendfeed", "twitter"  ]
	},
		
	discoverModule:
	{
		factory: "devhd.modules.createDiscoverModule",
		dependencies: [ "reader", "preferences", "suggesto", "feedly", "trends" ]
	},

	recommendsModule:
	{
		factory: "devhd.modules.createRecommendsModule",
		dependencies: [ "reader", "trends" ]
	},
	
	followsModule:
	{
		factory: "devhd.modules.createFollowsModule",
		dependencies: [ "reader" ]
	},
			
	sponsorsModule:
	{
		factory: "devhd.modules.createSponsorsModule",
		dependencies: [ "reader", "amazon", "preferences", "analytics" ]		
	},

	fusionModule:
	{
		factory: "devhd.modules.createFusionModule",
		dependencies: [ "io", "analytics" ]		
	},

	causesModule:
	{
		factory: "devhd.modules.createCausesModule",
		dependencies: [ "io", "analytics" ]		
	},

	aboutModule:
	{
		factory: "devhd.modules.createAboutModule",
		dependencies: [ "reader", "preferences" ]		
	},

	likersModule:
	{
		factory: "devhd.modules.createLikersModule",
		dependencies: [ "reader", "preferences" ]		
	},

	essentialsModule:
	{
		factory: "devhd.modules.createEssentialsModule",
		dependencies: [ "io", "analytics" ]		
	},
	
	financeModule:
	{
		factory: "devhd.modules.createFinanceModule",
		dependencies: [ "preferences", "quotes" ]		
	},
	
	favoriteSourcesModule:
	{
		factory: "devhd.modules.createSourcesModule",
		dependencies: [ "reader", "preferences", "feedly", "trends" ],
		properties:
		{
			group: "favorites",
			sortBy:"reading",
			max: 60
		}
	},
	
	dashboardModule:
	{
		factory: "devhd.modules.createDashboardModule",
		dependencies: [ "reader", "preferences", "feedly", "trends" ]
	},
	
	featuredModule:
	{
		factory: "devhd.modules.createFeaturedModule",
		dependencies: [ "reader", "preferences", "feedly", "trends" ]
	},

	otherSourcesModule:
	{
		factory: "devhd.modules.createSourcesModule",
		dependencies: [ "reader", "preferences", "feedly", "trends" ],
		properties:
		{
			group: "others",
			sortBy:"reading",
			max: 25
		}
	},

	tipsModule:
	{
		factory: "devhd.modules.createTipsModule",
		dependencies: []
	},

	bookmarkSuggestionsModule:
	{
		factory: "devhd.modules.createBookmarkSuggestionsModule",
		dependencies: []
	},

	googleSuggestionsModule:
	{
		factory: "devhd.modules.createGoogleSuggestionsModule",
		dependencies: []
	},

	twitterSuggestionsModule:
	{
		factory: "devhd.modules.createTwitterSuggestionsModule",
		dependencies: [ "twitter", "repo" ]
	},

	facebookSuggestionsModule:
	{
		factory: "devhd.modules.createFacebookSuggestionsModule",
		dependencies: []
	},
	
	
// ---------------------------------------------------------------------
// PROFILE DISCOVERY SERVICE
// ---------------------------------------------------------------------
	disco:
	{
		factory: "devhd.services.createDisco",
		properties:
		{
			agentIds: [ 
						"sitesAgent",
						"netvibesAgent", 
						"bloglinesAgent", 
						"blankAgent", 
						"googleAgent"
					  ]
		}
	},

			googleAgent:
			{
				factory: "devhd.services.createGoogleAgent",
				dependencies:[ "profile", "reader" ]
			},
			blankAgent:
			{
				factory: "devhd.services.createBlankAgent"
			},
			bloglinesAgent:
			{
				factory: "devhd.services.createBloglinesAgent",
				dependencies:["io" ]
			},
			sitesAgent:
			{
				factory: "devhd.services.createSitesAgent",
				dependencies:[ "bookmarks", "repo", "twitter", "facebook" ]
			},
			netvibesAgent:
			{
				factory: "devhd.services.createNetvibesAgent",
				dependencies:["io", "preferences" ]
			},

// ---------------------------------------------------------------------
// VARIOUS UI RELATED SERVICES
// ---------------------------------------------------------------------
	twitter:
	{
		factory: "devhd.services.createTwitter",
		dependencies: [ "preferences", "locator", "io","timers", "repo", "cache" ]
	},

	bundles:
	{
		factory: "devhd.services.createBundles",
		dependencies: [ "delicious", "repo", "twitter", "suggesto", "bookmarks", "reader", "google", "reco", "social" ]
	},

	channel:
	{
		factory: "devhd.services.createChannel",
		dependencies: [ "reader", "feedly" ]
	},
	
	edito:
	{
		factory: "devhd.services.createEdito",
		dependencies: [ "reader", "preferences", "trends" ]
	},
	
	effects:
	{
		factory: "devhd.services.createEffects"
	},
	
	ruler:
	{
		factory: "devhd.services.createRuler"
	},
	
	popup:
	{
		factory: "devhd.services.createPopup",
		dependencies: [ "preferences" ]
	}, 
	
	back:
	{
		factory: "devhd.services.createBack"
	},
	
	dialog:
	{
		factory: "devhd.services.createDialog"
	},
	
	progressDialog:
	{
		factory: "devhd.services.createProgressDialog",
		dependencies: [ "dialog" ]
	},

	quicklook:
	{
		factory: "devhd.services.createQuicklook",
		dependencies: [ "reader" ]
	},

	signs:
	{
		factory: "devhd.services.createSigns",
		dependencies: [ "preferences" ]
	},
	
    analytics:
	{
		factory: "devhd.services.createAnalytics",
		dependencies: [],
		properties:
		{
			accountId: "UA-3571881-3"
		}
	},

	helpSigns:
	{
		factory: "devhd.services.createHelpSigns",
		dependencies: [ "preferences" ]
	},
	
	quickGoto:
	{
		factory: "devhd.services.createQuickGoto",
		dependencies: [ "preferences", "reader", "feedly" , "sherlock" ,"effects" ]
	},

	hercule:
	{
		factory: "devhd.services.createHercule",
		dependencies: [ "preferences", "reader", "feedly", "twitter", "friendfeed" , "sherlock", "amazon", "suggesto" ]
	},
	
	kodak:
	{
		factory: "devhd.services.createKodak"
	}	
}
